<template>
	<view class="main-container">
		<page-header :fixedHeight="fixedHeight" :naviBarHeight="naviBarHeight"></page-header>
		<view class="share-container">
			<view :class="isBigiPhone ? 'logo-container-big' : 'logo-container'"></view>
			<view :class="isBigiPhone ? 'rotate-img-big' : 'rotate-img'" :style="{backgroundImage: 'url(' + rotateImgUrl + ')'}"></view>
			<view class="info-item" :class="isBigiPhone ? 'info-num-big' : 'info-num'">我正在为{{ shareNum }}号作品</view>
			<view class="info-item" :class="isBigiPhone ? 'info-name-big' : 'info-name'">{{ shareName }}打call</view>
			<view class="info-item" :class="isBigiPhone ? 'info-text-big' : 'info-text'">现在就差你这一票!</view>
			<view :class="isBigiPhone ? 'handle-container-big' : 'handle-container'">
				<view class="save-btn" @click="goHandle(0)"></view>
				<view class="back-btn" @click="goHandle(1)"></view>
			</view>
		</view>
		<painter class="painter" :dirty="true" v-if="palette != null" :palette="palette" @imgOK="onImgOK" @imgErr="onImgErr"></painter>
	</view>
</template>

<script>
import PageHeader from './pageHeader.vue';

export default {
	onLoad(options) {
		console.log('Share options === ', options);
		if (options.hasOwnProperty('info')) {
			this.itemId = options.info;
			// this.rotateImgUrl = this.itemList[this.itemId - 1].img;
			this.rotateImgUrl = 'https://ikea-mrm.woaap.com/images/meatball/cook/cook-big/' + this.itemId + '-1.png';
			this.shareNum = this.itemId;
			this.shareName = this.itemList[this.itemId - 1].desc;
		}
	},
	data() {
		return {
			fixedHeight: getApp().globalData.fixedHeight,
			naviBarHeight: getApp().globalData.naviBarHeight,
			isBigiPhone: null,
			rotateImgUrl: "",
			shareNum: "",
			shareName: "",
			itemId: "",
			itemList: [
				{
					name: '1',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/1-1.png',
					desc: '北京糖醋素丸子',
					like: 1234,
					from: '北京四元桥'
				},
				{
					name: '2',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/2-1.png',
					desc: '红烩肉丸',
					like: 12345,
					from: '北京西红门'
				},
				{
					name: '3',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/3-1.png',
					desc: '杭椒酱爆肉丸',
					like: 1234,
					from: '北京西红门'
				},
				{
					name: '4',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/4-1.png',
					desc: '桂花红烧肉丸',
					like: 12345,
					from: '北京西红门'
				},
				{
					name: '5',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/5-1.png',
					desc: '南乳汁烧肉丸',
					like: 1234,
					from: '北京西红门'
				},
				{
					name: '6',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/6-1.png',
					desc: '鱼香瑞典式肉丸',
					like: 12345,
					from: '成都成华'
				},
				{
					name: '7',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/7-1.png',
					desc: '属你最能“丸”',
					like: 1234,
					from: '成都高新'
				},
				{
					name: '8',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/8-1.png',
					desc: '“贵妃”肉丸',
					like: 1234,
					from: '成都高新'
				},
				{
					name: '9',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/9-1.png',
					desc: '火锅遇见丸子兄弟',
					like: 12345,
					from: '重庆'
				},
				{
					name: '10',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/10-1.png',
					desc: '什锦丸子披萨',
					like: 1234,
					from: '重庆'
				},
				{
					name: '11',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/11-1.png',
					desc: '富贵金汤捞',
					like: 1234,
					from: '重庆'
				},
				{
					name: '12',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/12-1.png',
					desc: '青芦笋烧椒蔬菜丸',
					like: 12345,
					from: '重庆'
				},
				{
					name: '13',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/13-1.png',
					desc: '脆香杏仁肉丸',
					like: 1234,
					from: '重庆'
				},
				{
					name: '14',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/14-1.png',
					desc: '飘香辣子肉丸',
					like: 12345,
					from: '重庆'
				},
				{
					name: '15',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/15-1.png',
					desc: '糖油粑粑裹圆子',
					like: 1234,
					from: '长沙'
				},
				{
					name: '16',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/16-1.png',
					desc: '西柠香菠肉丸',
					like: 12345,
					from: '大连'
				},
				{
					name: '17',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/17-1.png',
					desc: '芝士流心肉丸',
					like: 1234,
					from: '大连'
				},
				{
					name: '18',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/18-1.png',
					desc: 'BBQ肉丸配薯角',
					like: 1234,
					from: '佛山'
				},
				{
					name: '19',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/19-1.png',
					desc: '丝瓜鱼腐浸肉丸',
					like: 12345,
					from: '佛山'
				},
				{
					name: '20',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/20-1.png',
					desc: '素菜咖喱煮肉丸',
					like: 1234,
					from: '广州番禺'
				},
				{
					name: '21',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/21-1.png',
					desc: '黄金鸡肉丸配薯角',
					like: 1234,
					from: '广州天河'
				},
				{
					name: '22',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/22-1.png',
					desc: '叻沙汤浸双丸粉丝',
					like: 12345,
					from: '广州天河'
				},
				{
					name: '23',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/23-1.png',
					desc: '贵州酸汤烩肉丸',
					like: 1234,
					from: '贵阳'
				},
				{
					name: '24',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/24-1.png',
					desc: '黄金丸子',
					like: 12345,
					from: '贵阳'
				},
				{
					name: '25',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/25-1.png',
					desc: '肉丸三明治',
					like: 1234,
					from: '哈尔滨'
				},
				{
					name: '26',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/26-1.png',
					desc: '西湖桂花糖醋丸子',
					like: 12345,
					from: '杭州'
				},
				{
					name: '27',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/27-1.png',
					desc: '焦溜肉圆',
					like: 1234,
					from: '济南'
				},
				{
					name: '28',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/28-1.png',
					desc: '茄汁龙珠',
					like: 1234,
					from: '南京'
				},
				{
					name: '29',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/29-1.png',
					desc: '鸡汁干丝烩肉丸',
					like: 12345,
					from: '南京'
				},
				{
					name: '30',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/30-1.png',
					desc: '香沙芋艿烧肉丸',
					like: 1234,
					from: '南通'
				},
				{
					name: '31',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/31-1.png',
					desc: '金玉良丸',
					like: 1234,
					from: '宁波'
				},
				{
					name: '32',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/32-1.png',
					desc: '日式照烧肉丸',
					like: 12345,
					from: '青岛'
				},
				{
					name: '33',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/33-1.png',
					desc: '天妇罗肉丸串',
					like: 1234,
					from: '上海宝山'
				},
				{
					name: '34',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/34-1.png',
					desc: '“肉桂”遇上肉丸',
					like: 12345,
					from: '上海北蔡'
				},
				{
					name: '35',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/35-1.png',
					desc: '芝士土豆焗肉丸',
					like: 1234,
					from: '上海北蔡'
				},
				{
					name: '36',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/36-1.png',
					desc: '糖醋肉丸饭',
					like: 12345,
					from: '上海徐汇'
				},
				{
					name: '37',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/37-1.png',
					desc: '四喜丸子饭',
					like: 1234,
					from: '上海徐汇'
				},
				{
					name: '38',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/38-1.png',
					desc: '红烧肉丸饭',
					like: 1234,
					from: '上海徐汇'
				},
				{
					name: '39',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/39-1.png',
					desc: '金沙燕麦球',
					like: 12345,
					from: '上海杨浦'
				},
				{
					name: '40',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/40-1.png',
					desc: '金汤肉丸意面',
					like: 1234,
					from: '沈阳'
				},
				{
					name: '41',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/41-1.png',
					desc: '苏城尽带黄金甲',
					like: 1234,
					from: '苏州'
				},
				{
					name: '42',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/42-1.png',
					desc: '津门珍汁小丸子',
					like: 12345,
					from: '天津东丽'
				},
				{
					name: '43',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/43-1.png',
					desc: '天津糖醋肉圆',
					like: 1234,
					from: '天津中北'
				},
				{
					name: '44',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/44-1.png',
					desc: '无锡糖醋小丸子',
					like: 12345,
					from: '无锡'
				},
				{
					name: '45',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/45-1.png',
					desc: '大武汉热干丸子面',
					like: 1234,
					from: '武汉'
				},
				{
					name: '46',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/46-1.png',
					desc: '肉丸胡辣汤',
					like: 12345,
					from: '西安'
				},
				{
					name: '47',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/47-1.png',
					desc: '糖醋丸子',
					like: 1234,
					from: '西安'
				},
				{
					name: '48',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/48-1.png',
					desc: '蔬菜肉丸串',
					like: 1234,
					from: '西安'
				},
				{
					name: '49',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/49-1.png',
					desc: '肉丸地三鲜',
					like: 12345,
					from: '西安'
				},
				{
					name: '50',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/50-1.png',
					desc: '徐州干煸小丸子',
					like: 1234,
					from: '徐州'
				},
				{
					name: '51',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/51-1.png',
					desc: '徐州咖喱小丸子',
					like: 12345,
					from: '徐州'
				},
				{
					name: '52',
					img: 'https://ikea-mrm.woaap.com/images/meatball/cook/52-1.png',
					desc: '合家团圆',
					like: 1234,
					from: '郑州'
				}
			],
			palette: {},
			canvasScale: 3,
			postUrl: '',
			isfadeout: false
		};
	},
	mounted() {
		getApp().td_app_sdk.event({
			id: '/meatball/share',
			label: 'pv'
		});
		this.isBigiPhone = getApp().globalData.isBigiPhone;
		this.loadPainter();
	},
	methods: {
		loadPainter() {
			this.palette.width = `${750 * this.canvasScale}rpx`;
			this.palette.height = `${1351 * this.canvasScale}rpx`;
			this.palette.views = [];
			this.palette.views.push(
				{
					type: 'image',
					url: 'https://ikea-mrm.woaap.com/images/meatball/back-poster-back.png',
					css: {
						top: '0rpx',
						left: '0rpx',
						width: `${750 * this.canvasScale}rpx`,
						height: `${1351 * this.canvasScale}rpx`
					}
				},
				{
					type: 'image',
					url: this.rotateImgUrl,
					css: {
						top: `${(374 + 127) * this.canvasScale}rpx`,
						right: `${(60 + 8) * this.canvasScale}rpx`,
						width: `${450 * this.canvasScale}rpx`,
						height: `${450 * this.canvasScale}rpx`,
						rotate: '5.5'
					}
				},
				{
					type: 'text',
					text: `我正在为${this.shareNum}号作品 `,
					css: {
						top: `${387 * this.canvasScale}rpx`,
						left: `${29 * this.canvasScale}rpx`,
						fontSize: `${34 * this.canvasScale}rpx`,
						fontWeight: '200',
						color: '#fff',
						// height: `${52 * this.canvasScale}rpx`,
						lineHeight: `${44 * this.canvasScale}rpx`,
						background: 'linear-gradient(-90deg, transparent 0%, #d4b589 85%)',
					}
				},
				{
					type: 'text',
					text: this.shareName + '打call ',
					css: {
						top: `${446 * this.canvasScale}rpx`,
						left: `${29 * this.canvasScale}rpx`,
						fontSize: `${42 * this.canvasScale}rpx`,
						fontWeight: 'bold',
						color: '#fff',
						// height: `${52 * this.canvasScale}rpx`,
						lineHeight: `${52 * this.canvasScale}rpx`,
						background: 'linear-gradient(-90deg, transparent 0%, #d4b589 85%)',
					}
				},
				{
					type: 'text',
					text: '现在就差你这一票! ',
					css: {
						top: `${506 * this.canvasScale}rpx`,
						left: `${29 * this.canvasScale}rpx`,
						fontSize: `${34 * this.canvasScale}rpx`,
						fontWeight: '200',
						color: '#fff',
						// height: `${52 * this.canvasScale}rpx`,
						lineHeight: `${44 * this.canvasScale}rpx`,
						background: 'linear-gradient(-90deg, transparent 0%, #d4b589 85%)',
					}
				}
			)
			this.$forceUpdate();
		},
		onImgErr() {
			console.log("meatball onImgErr");
			uni.showToast({
				icon: 'none',
				title: '海报生成失败'
			});
		},
		onImgOK(e) {
			console.log("meatball onImgOK");
			console.log('postUrl === ', e.detail.path);
			this.$forceUpdate();
			this.postUrl = e.detail.path;
			uni.hideLoading();
			this.$nextTick(() => {
				this.isfadeout = true;
			})
		},
		goHandle(type) {
			if (type === 0) {
				getApp().td_app_sdk.event({
					id: 'meatball_share_长按保存',
					label: 'click'
				});
				console.log("Share Save");
				uni.showLoading({
					title: '请稍后',
					mask: true
				});
				uni.getSetting({
					success: res => {
						console.log(res);
						if (!res.authSetting['scope.writePhotosAlbum']) {
							uni.authorize({
								scope: 'scope.writePhotosAlbum',
								success: () => {
									//1.1 允许授权
									this.saveImg(this.postUrl);
								},
								fail() {
									//1.2 拒绝授权
									// 授权失败
									uni.showModal({
										title: '警告',
										content: '您点击了拒绝授权,将无法正常保存图片,点击确定重新获取授权。',
										success: function(res) {
											if (res.confirm) {
												uni.openSetting({
													success: res => {
														uni.showToast({
															icon: 'success',
															title: '授权成功',
															duration: 2000
														});
													}
												});
											}
										}
									});
								}
							});
						} else {
							this.saveImg(this.postUrl);
						}
					}
				});
			} else if (type === 1) {
				getApp().td_app_sdk.event({
					id: 'meatball_share_返回广场',
					label: 'click'
				});
				console.log("Share Back");
				uni.navigateTo({
					url: '/pages/meatball/list'
				})
			}
		},
		saveImg(url) {
			uni.showLoading({
				title: '图片保存中',
				mask: true
			});
			uni.saveImageToPhotosAlbum({
				filePath: url,
				success: () => {
					uni.hideLoading();
					uni.showToast({
						icon: 'success',
						title: '保存成功',
						duration: 2000
					});
				},
				fail() {
					uni.hideLoading();
					uni.showToast({
						icon: 'none',
						title: '保存失败',
						duration: 2000
					});
				}
			});
		},
		onShareAppMessage: res => {
			return {
				title: '票选人气肉丸 上榜宜家菜单',
				path: 'pages/meatball/index',
				imageUrl: 'https://ikea-mrm.woaap.com/images/meatball/share-back.jpg'
			};
		}
	},
	components: {
		PageHeader
	}
};
</script>

<style lang="scss" scoped>
.main-container {
	display: flex;
	justify-content: center;
	align-items: flex-start;
	flex-wrap: wrap;
	width: 100%;
	height: 100vh;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-share-back.png');
	background-size: cover;
	background-repeat: no-repeat;
	background-position: center;
	overflow: hidden;
	position: relative;
}
.share-container {
	width: 100%;
	height: 100vh;
	display: flex;
	align-content: flex-start;
	position: relative;
}
.logo-container {
	width: 114rpx;
	height: 46rpx;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-logo.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	position: absolute;
	left: 35rpx;
	// top: 131rpx;
	top: 168rpx;
}
.logo-container-big {
	width: 114rpx;
	height: 46rpx;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-logo.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	position: absolute;
	left: 35rpx;
	// top: 179rpx;
	top: 216rpx;
}
.rotate-img {
	position: absolute;
	// right: 60rpx;
	// top: 374rpx;
	right: 58rpx;
	top: 380rpx;
	width: 450rpx;
	height: 450rpx;
	transform: rotate(5.5deg);
	background-size: cover;
	background-repeat: no-repeat;
	background-position: center;
}
.rotate-img-big {
	position: absolute;
	// right: 60rpx;
	// top: 514rpx;
	right: 58rpx;
	top: 520rpx;
	width: 450rpx;
	height: 450rpx;
	transform: rotate(5.5deg);
	background-size: cover;
	background-repeat: no-repeat;
	background-position: center;
}
.info-item {
	padding-right: 13rpx;
	height: 52rpx;
	line-height: 52rpx;
	color: #fff;
	background: linear-gradient(to right, transparent 15%, #d4b589);
}
.info-num {
	position: absolute;
	left: 29rpx;
	top: 380rpx;
	font-size: 34rpx;
	font-weight: 200;
}
.info-name {
	position: absolute;
	left: 29rpx;
	top: 440rpx;
	font-size: 42rpx;
	font-weight: bold;
}
.info-text {
	position: absolute;
	left: 29rpx;
	top: 499rpx;
	font-size: 34rpx;
	font-weight: 200;
}
.info-num-big {
	position: absolute;
	left: 29rpx;
	top: 520rpx;
	font-size: 34rpx;
	font-weight: 200;
}
.info-name-big {
	position: absolute;
	left: 29rpx;
	top: 580rpx;
	font-size: 42rpx;
	font-weight: bold;
}
.info-text-big {
	position: absolute;
	left: 29rpx;
	top: 639rpx;
	font-size: 34rpx;
	font-weight: 200;
}
.handle-container {
	width: 715rpx;
	height: 387rpx;
	margin: 898rpx auto 0 auto;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-share-save-back.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	display: flex;
	flex-wrap: wrap;
	justify-content: center;
	align-content: start;
}
.handle-container-big {
	width: 715rpx;
	height: 387rpx;
	margin: 1048rpx auto 0 auto;
	background-image: url('https://ikea-mrm.woaap.com/images/meatball/back-share-save-back.png');
	background-size: 100%;
	background-repeat: no-repeat;
	background-position: center;
	display: flex;
	flex-wrap: wrap;
	justify-content: center;
	align-content: start;
}
.save-btn {
	width: 559rpx;
	height: 95rpx;
	margin-bottom: 36rpx;
	margin-top: 83rpx;
}
.back-btn {
	width: 559rpx;
	height: 95rpx;
}
.painter {
	position: absolute;
	left: 0;
	top: 200vh;
	// top: 0;
	// z-index: 10;
}
</style>
